{#
 # This file is part of the DATAtourisme project.
 # @author Conjecto <contact@conjecto.com>
 # 2022
 # SPDX-License-Identifier: GPL-3.0-or-later
 # For the full copyright and license information, please view the LICENSE file that was distributed with this source code.
 #}

{% extends 'flux/detail.html.twig' %}
{% import '_includes/macros.html.twig' as appMacros %}
{% import "DatatourismeWebAppBundle::macros.html.twig" as macros %}

{% block subcontent %}
    {% set last_process = flux.getLastProcess('complete') %}

    <table class="table table-responsive table-hover m-b-0">
        <thead>
        <tr>
            <th>{{ "label.date_hour" | trans }}</th>
            <th>{{ appMacros.help_toolstip('help.process_format') }} {{ "label.format" | trans }}</th>
            <th>{{ appMacros.help_toolstip('help.process_size') }} {{ "label.size" | trans }}</th>
            <th>{{ appMacros.help_toolstip('help.process_poi_count') }} {{ "label.poi_count" | trans }}</th>
            <th>{{ "label.download_link" | trans }}</th>
        </tr>
        </thead>
        <tbody>
            {% if flux.scheduleHour is not null %}
                <tr>
                    <td>
                        {% if last_process and last_process.status == 'running' %}
                            <span class="label label-info"><i class="fa fa-refresh fa-spin"></i> &nbsp;{{ "label.status.generating" | trans }}</span>
                        {% elseif last_process and last_process.status == 'wait' %}
                            <span class="label label-info"><i class="fa fa-clock-o"></i> &nbsp;{{ "label.status.preparing_generation" | trans }}</span>
                        {% else %}
                            <span class="label label-info"><i class="fa fa-clock-o"></i> &nbsp;{{ "label.status.scheduled" | trans({"%time%": "%02d:00"|format(flux.scheduleHour)}) }}</span>
                        {% endif %}
                    </td>
                    <td>{{ flux.outputType }}</td>
                    <td>-</td>
                    <td>-</td>
                    <td><label class="label label-default">{{ "label.status.wait" | trans }}</label></td>
                </tr>
            {% endif %}
            {% for process in items %}
                <tr>
                    <td>
                        <span data-tooltip='{"side":"right"}' title="{{ process.createdAt | localizeddate }}">
                            {{ (process.createdAt | moment).calendar() | capitalize }}
                        </span>
                    </td>
                    <td>
                        {{ process.outputType}}
                    </td>
                    <td>
                        {{ process.size ? appMacros.bytesToSize(process.size) : "-" }}
                    </td>
                    <td>
                        {{ process.nbrPoi is not null ? process.nbrPoi : "-" }}
                    </td>
                    <td>
                        {% if process.status == constant('AppBundle\\Entity\\Flux\\Process::STATUS_ERROR') %}
                            <span class="label label-danger"{% if is_granted('ROLE_ADMIN', app.user) %} title="{{ process.logs|join("\n") }}"{% endif %}><i class="fa fa-exclamation-circle fa-fw"></i> Erreur</span>
                        {% endif %}

                        {% if is_granted('flux.download',flux) %}
                            {% if process == flux.getLastSuccessProcess('complete')  %}
                            <a href="{{ path('flux.download.complete.get', {id: flux.id}) }}" class="btn btn-primary btn-xs"><i class="fa fa-download"></i>
                                {% if process.status == constant('AppBundle\\Entity\\Flux\\Process::STATUS_ERROR') %}
                                    {{ "btn.download_last_version" | trans }}
                                {% else %}
                                    {{ "btn.download" | trans }}
                                {% endif %}
                            </a>
                            {% endif %}
                        {% endif %}
                    </td>
                </tr>
            {% endfor %}
        </tbody>
    </table>

    {% if items | length == 0 and flux.scheduleHour is null %}
        <div class="blankslate blankslate-spacious">
            <h3>{{ "text.processes_no_result" | trans }}</h3>
            <p>{{ "help.processes_no_result" | trans | raw }}</p>
        </div>
    {% endif %}

    {% if list.totalItemCount > page_size %}
        <div class="box-footer">
            {{ macros.display_list_position(list, page_size) }}
            {{ knp_pagination_render(list.pagination, null, [], {class: "pagination-sm no-margin pull-right"}) }}
        </div>
    {% endif %}

{% endblock %}